Page MenuHomePhabricator

Score should support note names in other languages
Closed, ResolvedPublic

Description

LilyPond supports notes names in many languages (1) and specialist notations (2). The file "italiano.ly" is particularly useful because many countries use solmization systems and not the alphabetic system (3) which seems to be the only one supported in this extension. Could you add the support of LilyPond language files please? Thanks in advance.

  1. http://lilypond.org/doc/v2.12/Documentation/user/lilypond/Writing-pitches#Note-names-in-other-languages
  2. http://lilypond.org/doc/v2.12/Documentation/user/lilypond/Specialist-notation.html
  3. https://en.wikipedia.org/wiki/Key_signature_names_and_translations

Version: unspecified
Severity: enhancement

Details

Reference
bz47604

Event Timeline

bzimport raised the priority of this task from to Normal.
bzimport set Reference to bz47604.
bzimport added a subscriber: Unknown Object (MLST).
Ayack created this task.Apr 24 2013, 12:09 PM

Hmm, including files, even things like italiano.ly currently gets disabled via -dsafe

I suppose we could manually include them in a preprocessing step if they're from a list of safe sources, or something like that.

Ayack added a comment.May 12 2013, 9:01 AM

It would be great!

The files "italiano.ly" and "gregorian.ly" (imho the most useful) are standard LilyPond files, so they shouldn't be a security problem.

Ayack added a comment.Aug 24 2013, 4:45 PM

Is anyone willing (and able) to include these files as explained by Bawolff please?

jeanluc.thiebaut wrote:

In the case of "italiano.ly",
this file contains only (useful lines) : \language "italiano"

The following code should work :

<score>
\language "italiano"
\relative do' {do4 mi sol do}
</score>

Yann added a comment.Dec 16 2013, 7:10 PM

This is important for a good localisation of the Score extension. Other languages than English should be able to use their local notation. Thanks, Yann

Ayack added a comment.Dec 16 2013, 7:28 PM

(In reply to comment #5)

This is important for a good localisation of the Score extension. Other
languages than English should be able to use their local notation. Thanks,
Yann

Yes, and please do not forget "gregorian.ly" which would allow us to make available many medieval pieces.

rickard.pontus.olof.lind wrote:

(In reply to comment #6)

(In reply to comment #5)
> This is important for a good localisation of the Score extension. Other
> languages than English should be able to use their local notation. Thanks,
> Yann

Yes, and please do not forget "gregorian.ly" which would allow us to make
available many medieval pieces.

I think "gregorian.ly" should be High priority!

If there is no separate feature request for gregorian.ly, please file one as it's a separate issue. See https://www.mediawiki.org/wiki/How_to_report_a_bug for general information. it It won't be high priority as per https://www.mediawiki.org/wiki/Bugzilla/Fields#Priority but providing patches speeds up the process.

(In reply to comment #7)

(In reply to comment #6)
> (In reply to comment #5)
> > This is important for a good localisation of the Score extension. Other
> > languages than English should be able to use their local notation. Thanks,
> > Yann
>
> Yes, and please do not forget "gregorian.ly" which would allow us to make
> available many medieval pieces.

I think "gregorian.ly" should be High priority!

Its unlikely we are going to rewrite lillypond's safemode. Sorry.

rickard.pontus.olof.lind wrote:

(In reply to comment #9)

(In reply to comment #7)
> (In reply to comment #6)
> > (In reply to comment #5)
> > > This is important for a good localisation of the Score extension. Other
> > > languages than English should be able to use their local notation. Thanks,
> > > Yann
> >
> > Yes, and please do not forget "gregorian.ly" which would allow us to make
> > available many medieval pieces.
>
> I think "gregorian.ly" should be High priority!

Its unlikely we are going to rewrite lillypond's safemode. Sorry.

Then it is a LilyPond issue to incorporate the features of gregorian.ly into the regular interpreter. Am I right? Then it should be a LilyPond feature request.

Lilypond feature requests must go to http://code.google.com/p/lilypond/issues/list instead.

Ayack added a comment.Mar 28 2014, 3:32 PM

(In reply to Rickard Lind from comment #10)

(In reply to comment #9)
> (In reply to comment #7)
> > (In reply to comment #6)
> > > (In reply to comment #5)
> > > > This is important for a good localisation of the Score extension. Other
> > > > languages than English should be able to use their local notation. Thanks,
> > > > Yann
> > >
> > > Yes, and please do not forget "gregorian.ly" which would allow us to make
> > > available many medieval pieces.
> >
> > I think "gregorian.ly" should be High priority!
>
> Its unlikely we are going to rewrite lillypond's safemode. Sorry.

Then it is a LilyPond issue to incorporate the features of gregorian.ly into
the regular interpreter. Am I right? Then it should be a LilyPond feature
request.

I'm not sure, but it seems that this feature was incorporated in LilyPond in 2010: https://code.google.com/p/lilypond/issues/detail?id=903

This issue should be solved for a while then, but it is still present. How is it possible?

rickard.pontus.olof.lind wrote:

(In reply to Ayack from comment #12)

(In reply to Rickard Lind from comment #10)
> (In reply to comment #9)
> > (In reply to comment #7)
> > > (In reply to comment #6)
> > > > (In reply to comment #5)
> > > > > This is important for a good localisation of the Score extension. Other
> > > > > languages than English should be able to use their local notation. Thanks,
> > > > > Yann
> > > >
> > > > Yes, and please do not forget "gregorian.ly" which would allow us to make
> > > > available many medieval pieces.
> > >
> > > I think "gregorian.ly" should be High priority!
> >
> > Its unlikely we are going to rewrite lillypond's safemode. Sorry.
>
> Then it is a LilyPond issue to incorporate the features of gregorian.ly into
> the regular interpreter. Am I right? Then it should be a LilyPond feature
> request.

I'm not sure, but it seems that this feature was incorporated in LilyPond in
2010: https://code.google.com/p/lilypond/issues/detail?id=903

This issue should be solved for a while then, but it is still present. How
is it possible?

The code included with \include "italiano.ly" was apparently quite simple code unlike gregorian.ly and fixed with a new \lanugage command. This does not include what is in gregorian.ly. See: https://codereview.appspot.com/2699041/

Ayack added a comment.Mar 28 2014, 4:48 PM

(In reply to Rickard Lind from comment #13)

(In reply to Ayack from comment #12)
> (In reply to Rickard Lind from comment #10)
> > (In reply to comment #9)
> > > (In reply to comment #7)
> > > > (In reply to comment #6)
> > > > > (In reply to comment #5)
> > > > > > This is important for a good localisation of the Score extension. Other
> > > > > > languages than English should be able to use their local notation. Thanks,
> > > > > > Yann
> > > > >
> > > > > Yes, and please do not forget "gregorian.ly" which would allow us to make
> > > > > available many medieval pieces.
> > > >
> > > > I think "gregorian.ly" should be High priority!
> > >
> > > Its unlikely we are going to rewrite lillypond's safemode. Sorry.
> >
> > Then it is a LilyPond issue to incorporate the features of gregorian.ly into
> > the regular interpreter. Am I right? Then it should be a LilyPond feature
> > request.
>
> I'm not sure, but it seems that this feature was incorporated in LilyPond in
> 2010: https://code.google.com/p/lilypond/issues/detail?id=903
>
> This issue should be solved for a while then, but it is still present. How
> is it possible?

The code included with \include "italiano.ly" was apparently quite simple
code unlike gregorian.ly and fixed with a new \lanugage command. This does
not include what is in gregorian.ly. See:
https://codereview.appspot.com/2699041/

Maybe, but "italiano.ly" is not working either...

rickard.pontus.olof.lind wrote:

(In reply to Ayack from comment #14)

(In reply to Rickard Lind from comment #13)
> (In reply to Ayack from comment #12)
> > (In reply to Rickard Lind from comment #10)
> > > (In reply to comment #9)
> > > > (In reply to comment #7)
> > > > > (In reply to comment #6)
> > > > > > (In reply to comment #5)
> > > > > > > This is important for a good localisation of the Score extension. Other
> > > > > > > languages than English should be able to use their local notation. Thanks,
> > > > > > > Yann
> > > > > >
> > > > > > Yes, and please do not forget "gregorian.ly" which would allow us to make
> > > > > > available many medieval pieces.
> > > > >
> > > > > I think "gregorian.ly" should be High priority!
> > > >
> > > > Its unlikely we are going to rewrite lillypond's safemode. Sorry.
> > >
> > > Then it is a LilyPond issue to incorporate the features of gregorian.ly into
> > > the regular interpreter. Am I right? Then it should be a LilyPond feature
> > > request.
> >
> > I'm not sure, but it seems that this feature was incorporated in LilyPond in
> > 2010: https://code.google.com/p/lilypond/issues/detail?id=903
> >
> > This issue should be solved for a while then, but it is still present. How
> > is it possible?
>
> The code included with \include "italiano.ly" was apparently quite simple
> code unlike gregorian.ly and fixed with a new \lanugage command. This does
> not include what is in gregorian.ly. See:
> https://codereview.appspot.com/2699041/

Maybe, but "italiano.ly" is not working either...

Does \language "italiano" work?

Ayack added a comment.Mar 28 2014, 5:01 PM

(In reply to Rickard Lind from comment #15)

(In reply to Ayack from comment #14)
> (In reply to Rickard Lind from comment #13)
> > (In reply to Ayack from comment #12)
> > > (In reply to Rickard Lind from comment #10)
> > > > (In reply to comment #9)
> > > > > (In reply to comment #7)
> > > > > > (In reply to comment #6)
> > > > > > > (In reply to comment #5)
> > > > > > > > This is important for a good localisation of the Score extension. Other
> > > > > > > > languages than English should be able to use their local notation. Thanks,
> > > > > > > > Yann
> > > > > > >
> > > > > > > Yes, and please do not forget "gregorian.ly" which would allow us to make
> > > > > > > available many medieval pieces.
> > > > > >
> > > > > > I think "gregorian.ly" should be High priority!
> > > > >
> > > > > Its unlikely we are going to rewrite lillypond's safemode. Sorry.
> > > >
> > > > Then it is a LilyPond issue to incorporate the features of gregorian.ly into
> > > > the regular interpreter. Am I right? Then it should be a LilyPond feature
> > > > request.
> > >
> > > I'm not sure, but it seems that this feature was incorporated in LilyPond in
> > > 2010: https://code.google.com/p/lilypond/issues/detail?id=903
> > >
> > > This issue should be solved for a while then, but it is still present. How
> > > is it possible?
> >
> > The code included with \include "italiano.ly" was apparently quite simple
> > code unlike gregorian.ly and fixed with a new \lanugage command. This does
> > not include what is in gregorian.ly. See:
> > https://codereview.appspot.com/2699041/
>
> Maybe, but "italiano.ly" is not working either...

Does \language "italiano" work?

No. I tried:

<score>
\language "italiano"
{ do re mi fa sol la si }
</score>

which generated:

Impossible de compiler le fichier d’entrée LilyPond :

Processing `.../file.ly'
Parsing...
.../file.ly:13:0: error: syntax error, unexpected '{'

{ do re mi fa sol la si }
.../file.ly:22:24: error: syntax error, unexpected '}'

}error: failed files: ".../file.ly"

exited with status: 1

(Cf. https://fr.wikipedia.org/wiki/Utilisateur:Ayack/Brouillon/Score)

Ayack added a comment.Mar 28 2014, 5:05 PM

<score lang="italiano">
{ do re mi fa sol la si }
</score>

Doesn't work either.

jeanluc.thiebaut wrote:

"language" works when using raw mode :

<score raw vorbis>
\score {
<<
\language "italiano"
\relative do' { do re mib fad sol la sib do }

\layout { }
\midi {  }

}
</score>

Ayack added a comment.Apr 7 2014, 3:43 PM

Ok, so, if I have understood correctly, the bug is:

"Score should support the following languages in standard mode:
arabic.ly
catalan.ly
deutsch.ly
english.ly
espanol.ly
italiano.ly
nederlands.ly
norsk.ly
portugues.ly
suomi.ly
svenska.ly
vlaams.ly"

Jdforrester-WMF moved this task from Untriaged to Backlog on the Multimedia board.Sep 4 2015, 6:39 PM
Restricted Application added subscribers: Matanya, Aklapper. · View Herald TranscriptSep 4 2015, 6:39 PM
Ebe123 lowered the priority of this task from Normal to Low.Sep 13 2017, 11:32 PM
Ebe123 moved this task from In Progress to Backlog on the MediaWiki-extensions-Score board.
Ebe123 added a subscriber: Ebe123.

The \language statement works fine. It just can't be scoped inside the \score statement as done when not in raw mode. Maybe add as a parameter, as this does seem like something that should be available in the simple mode.

Base added a subscriber: Base.Nov 25 2017, 6:52 AM
nikitavbv claimed this task.Jan 3 2018, 9:07 PM
nikitavbv added a subscriber: nikitavbv.

Looks interesting! I will work on adding support for this.

Change 401820 had a related patch set uploaded (by Phantom42; owner: Phantom42):
[mediawiki/extensions/Score@master] Add support for notes languages

https://gerrit.wikimedia.org/r/401820

Change 401820 merged by jenkins-bot:
[mediawiki/extensions/Score@master] Add support for notes languages

https://gerrit.wikimedia.org/r/401820

nikitavbv closed this task as Resolved.Jan 4 2018, 9:04 PM

Closing this as resolved because the patch is merged now. This is one more step in making this extension better support score writing in different languages!

Ayack added a comment.Jan 8 2018, 8:18 PM
In T49604#3876541, @Phantom42 wrote:

Closing this as resolved because the patch is merged now. This is one more step in making this extension better support score writing in different languages!

Thanks @Phantom42! It's a major step for this extension. Is your patch adding support for "gregorian.ly" or "only" current languages?

Languages added by this change are:

arabic.ly
catalan.ly
deutsch.ly
english.ly
espanol.ly
italiano.ly
nederlands.ly
norsk.ly
portugues.ly
suomi.ly
svenska.ly
vlaams.ly

Languages can be switched by using note-language attribute, for example:

<score note-language="italiano">
...
</score>

Unluckily, this patch does not add "gregorian.ly" support, as it is not the language which is supported by \language statement.